!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! 2003.01.31 ORDynaString	[Z, GLULX]
! ORDynaString is a quick class to facilitate creation and printing of dynamic text.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!--------------------------------------------------------------------------------------
! Created by Jim Fisher
! AutoDep:	none
!--------------------------------------------------------------------------------------
! A more detailed description of this file, what it does, and how to use it goes here.
!
!--------------------------------------------------------------------------------------
! To register this module with your library, add the line:
!
!		#include "ORDynaString";					!Constant USE_ORDynaString; 
!	
!	to the library header file (OR_Library_Include).  To use in a game, add the line:
!
!		Constant USE_ORDynaString; to the game file;
!
!	to the game file;
!--------------------------------------------------------------------------------------
! Revision History
! 2001.12.26	Initial Creation (not really, but this was the earliest date I could 
!				find without searching my code archive)
! 2002.02.13	Added Glulx support 
! 2002.02.25	Finalized Glulx support.  Also made objects utilize zero-based index.
! 2002.02.26	Fit to new template.
! 2003.01.31	Added routine to print partial strings (substring)
!--------------------------------------------------------------------------------------
#ifdef USE_ORDynaString;message "          Processing library extension ORDynaString...";
!--------------------------------------------------------------------------------------
! D E P E N D A N C I E S   section   (for bringing in dependant modules)
!--- sample forced include---   #ifndef USE_<REPLACEWITHINCLUDENAME>; Constant USE_<REPLACEWITHINCLUDENAME>; message "          ****Forcing inclusion of <REPLACEWITHINCLUDENAME>****"; #include "<REPLACEWITHINCLUDENAME>"; #endif; 
!--- #ifndef TARGET_GLULX; default WORDSIZE 2; #ifnot;default WORDSIZE 4; #endif; !--for GLULX compatability
!--------------------------------------------------------------------------------------


!--------------------------------------------------------------------------------------
#ifdef REPLACEPOINT; #ifndef ORDynaString_DONEREPLACE; constant ORDynaString_DONEREPLACE; 
!--------------------------------------------------------------------------------------
! R E P L A C E   section (for code that preceeds the inclusion of PARSER)
!--------------------------------------------------------------------------------------

!--------------------------------------------------------------------------------------
#endif;#endif;#ifdef MESSAGEPOINT; #ifndef ORDynaString_DONEMESSAGE; constant ORDynaString_DONEMESSAGE; 
!--------------------------------------------------------------------------------------
! M E S S A G E   section (for code that falls between PARSER and VERBLIB )
!--- Uncomment to check for OREnglish--- #ifndef OREnglish; message "ERROR!!!! ORDynaString requires the OREnglish file.";#endif; 
!--------------------------------------------------------------------------------------
	system_file;
	
	#ifndef ORDynaBuf; array ORDynaBuf -> 1000; #endif;
	class ORDynaString
	with	buf ORDynaBuf
		,	sv 0
		,	matches[o t;
				if(o ofclass object){
					if(~~(o ofclass ORDynaBuf)) rfalse;
					o=o.buf; !--is a dynabuf, so get the actual buffer...
				}
				if(o==0)rfalse; !--if not initialized, then error 
				for(t=0:t<self.length()+WORDSIZE:t++){  !--check all including length
					if(self.buf->(t)~=o->(t)) rfalse;
				}
				rtrue;
			]
		,	capture[a;
				a=self.buf;
	#ifndef TARGET_GLULX;
			@output_stream 3 a;	!capture output to an array
	#ifnot;
			self.sv=glk_stream_get_current();
			glk_stream_set_current(glk_stream_open_memory(a+WORDSIZE, 1000, filemode_Write, 662));
	#endif;
			]
		,	release[;
		#ifndef TARGET_GLULX;
			@output_stream -3;		!release output back to screen
		#ifnot;
			glk_stream_close(glk_stream_get_current(), gg_arguments);
			glk_stream_set_current(self.sv);
			(self.buf-->0)=gg_arguments-->1;
		#endif;
			]
		,	substring[start count i len;
				len=(self.buf-->0);
				if(start+count>len)count=len-start;
				for(i=start:i<count:i++) 
					print (char) (self.buf)->(i+WORDSIZE); 
			]
		,	print[o;
				if(o==0) o=self.buf;
				print (arraystring) o;
			]
		,	islower[v;
#ifndef TARGET_GLULX;
				if(v>96 && v<123) rtrue; rfalse;
#ifnot;
				if(v==glk_char_to_lower(v)) rtrue; rfalse;
#endif;
			]
		,	isupper[v;
#ifndef TARGET_GLULX;
				if(v>64 && v<91) rtrue; rfalse;
#ifnot;
				if(v==glk_char_to_upper(v)) rtrue; rfalse;
#endif;
			]
		,	get_char[n;
				n=n+WORDSIZE;
				return ((self.buf)->n);
			]
		,	set_char[n val;
				n=n+WORDSIZE;
				((self.buf)->n)=val;
			]
		,	length [;return (self.buf-->0);]
		,	upper[n t;
				n=n+WORDSIZE;
				t=((self.buf)->n);
				if(self.islower(t)) {
#ifndef TARGET_GLULX;
					((self.buf)->n)=t-32;
#ifnot;
					((self.buf)->n)=glk_char_to_upper(t);
#endif;
				}
			]
		,	lower[n t;
				n=n+WORDSIZE;
				t=((self.buf)->n);
				if(self.isupper(t)) {
#ifndef TARGET_GLULX;
					((self.buf)->n)=t+32;	
#ifnot;
					((self.buf)->n)=glk_char_to_lower(t);
#endif;
				}
			]
		,	upper_all[t;
				for(t=0:t<self.length():t++){
					self.upper(t);
				}
			]
		,	lower_all[t;
				for(t=0:t<self.length():t++){
					self.lower(t);
				}
			]
	;
	[dynastring o;	o.print();]; !works with both strings and dynastrings
!--------------------------------------------------------------------------------------
#endif; #endif; #ifdef CODEPOINT; #ifndef ORDynaString_DONECODE;constant ORDynaString_DONECODE; 
!--------------------------------------------------------------------------------------
! C O D E   section (for code that falls between VERBLIB and GRAMMAR)
!--------------------------------------------------------------------------------------


!--------------------------------------------------------------------------------------
#endif; #endif; #ifdef GRAMMARPOINT; #ifndef ORDynaString_DONEGRAMMAR; constant ORDynaString_DONEGRAMMAR; #ifdef ORDynaString_DONEGRAMMAR; #endif; !--just to supress warning
!--------------------------------------------------------------------------------------
! G R A M M A R   section (for code that follows the inclusion of GRAMMAR)
!--------------------------------------------------------------------------------------


!--------------------------------------------------------------------------------------
#endif; #endif; #endif;