!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! 2003.03.29 ORStyleRvrsMonospace	[GLULX]
! Defines the Style_RvrsMonospace text style.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!--------------------------------------------------------------------------------------
! Created by Jim Fisher
! AutoDep (Glulx-only) :	ORStyleHint
!							ORInfGlk
!--------------------------------------------------------------------------------------
! This module defines a user defined style for the text buffer in a bold, fixed width 
! font.  The constant "Style_BoldMonospace" is defaulted to style_User2, however this 
! defined to a diffent value in the game souce code. 
!--------------------------------------------------------------------------------------
! To register this module with your library, add the line:
!
!		#include "ORStyleRvrsMonospace";					!Constant USE_ORStyleRvrsMonospace; 
!	
!	to the library header file (OR_Library_Include).  To use in a game, add the line:
!
!		Constant USE_ORStyleRvrsMonospace; to the game file;
!
!	to the game file;
!--------------------------------------------------------------------------------------
! Revision History
! 2002.02.11	Initial Creation
! 2002.02.20	Actually made reverse, instead of bold.
! 2002.02.26	Fit to new template.
! 2002.02.27	added #ifdef to suppress warning in Z-Code mode.
! 2002.04.03	modified faulty WORDSIZE definition.
! 2003.03.29	Modified modified to default to the style_Preformatted value rather 
!				than user2.
!--------------------------------------------------------------------------------------
#ifdef USE_ORStyleRvrsMonospace;
	#ifdef TARGET_GLULX;
		message "          Processing library extension ORStyleRvrsMonospace...";
	#ifnot;
		message "          Processing library extension ORStyleRvrsMonospace...Ignoring (GLULX specific)";
	#endif;
!--------------------------------------------------------------------------------------
! D E P E N D A N C I E S   section   (for bringing in dependant modules)
!--- sample forced include---   #ifndef USE_<REPLACEWITHINCLUDENAME>; Constant USE_<REPLACEWITHINCLUDENAME>; message "          ****Forcing inclusion of <REPLACEWITHINCLUDENAME>****"; #include "<REPLACEWITHINCLUDENAME>"; #endif; 
!--- #ifndef TARGET_GLULX; default WORDSIZE 2; #ifnot;default WORDSIZE 4; #endif; !--for GLULX compatability
!--------------------------------------------------------------------------------------
	#ifdef TARGET_GLULX;
		#ifndef USE_ORInfGlk; Constant USE_ORInfGlk; message "          ****Forcing inclusion of ORInfGlk****"; #include "ORInfGlk"; #endif; 
		#ifndef USE_ORStyleHint; Constant USE_ORStyleHint; message "          ****Forcing inclusion of ORStyleHint****"; #include "ORStyleHint"; #endif; 
	#endif;
!--------------------------------------------------------------------------------------
#ifdef REPLACEPOINT; #ifndef ORStyleRvrsMonospace_DONEREPLACE; constant ORStyleRvrsMonospace_DONEREPLACE; 
!--------------------------------------------------------------------------------------
! R E P L A C E   section (for code that preceeds the inclusion of PARSER)
!--------------------------------------------------------------------------------------

!--------------------------------------------------------------------------------------
#endif;#endif;#ifdef MESSAGEPOINT; #ifndef ORStyleRvrsMonospace_DONEMESSAGE; constant ORStyleRvrsMonospace_DONEMESSAGE; 
!--------------------------------------------------------------------------------------
! M E S S A G E   section (for code that falls between PARSER and VERBLIB )
!--- Uncomment to check for OREnglish--- #ifndef OREnglish; message "ERROR!!!! ORStyleRvrsMonospace requires the OREnglish file.";#endif; 
!--------------------------------------------------------------------------------------

!--------------------------------------------------------------------------------------
#endif; #endif; #ifdef CODEPOINT; #ifndef ORStyleRvrsMonospace_DONECODE;constant ORStyleRvrsMonospace_DONECODE; 
!--------------------------------------------------------------------------------------
! C O D E   section (for code that falls between VERBLIB and GRAMMAR)
!--------------------------------------------------------------------------------------
	#ifdef TARGET_GLULX;
		default style_RvrsMonospace style_Preformatted; !--if not already defined, then use the style_preformatted value (the only value not used by the library other than emphasized and the user-defined values)

		ORStyleHint	with user_num	style_RvrsMonospace
			,	windows wintype_TextBuffer 
			,	hints stylehint_ReverseColor stylehint_Proportional 
			,	values 1 0 
		;
		ORStyleHint	with user_num	style_RvrsMonospace !--in the text grid, all the text is reversed by default, so non-reversal is really reversal
			,	windows wintype_TextGrid
			,	hints stylehint_ReverseColor stylehint_Proportional 
			,	values 0 0 
		;
	#endif;
!--------------------------------------------------------------------------------------
#endif; #endif; #ifdef GRAMMARPOINT; #ifndef ORStyleRvrsMonospace_DONEGRAMMAR; constant ORStyleRvrsMonospace_DONEGRAMMAR; #ifdef ORStyleRvrsMonospace_DONEGRAMMAR; #endif; !--just to supress warning
!--------------------------------------------------------------------------------------
! G R A M M A R   section (for code that follows the inclusion of GRAMMAR)
!--------------------------------------------------------------------------------------


!--------------------------------------------------------------------------------------
#endif; #endif; #endif;