!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! 2003.07.07 OR_Library_Include [Z, GLULX]
!!!	This file serves as a common entry point for all ORLibrary entries.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
!--------------------------------------------------------------------------------------
! Created by Jim Fisher
! The latest version of the OnyxRing Library for Inform can be found in its 
! entirety at:
!
!		http://www.OnyxRing.com/orlibrary.aspx
!		
! Alternativly, the basic ORLibrary framework and each of the entries can also be 
! downloaded seperately. 
!	
! Note, the ORLibrary is best maintained in its own directory which is then added to the 
! path on the commandline as in the following example:
!
!		inform +language_name=OREnglish +include_path=\inform\ORLibrary,\inform\standardlibrary -~Ddd2  mygame.inf
!
!--------------------------------------------------------------------------------------
default ORLibVersion "1.0C";
default ORLibDateStamp "2003.12.13";
!--------------------------------------------------------------------------------------
!	The following code determines which section we are creating includes for...
!--------------------------------------------------------------------------------------
#ifndef ORFIRSTPASS; message "Compiling with the  O R L i b r a r y  framework";constant ORFIRSTPASS; #endif; 
#ifndef USE_ORBanner; message "          ****Forcing inclusion of ORBanner (from common include file)****"; constant USE_ORBanner; #endif; 
#ifdef GRAMMARPOINT; !--if already processed grammar stuff then error out.
	message "Error", "Attempting to process the Extension file too many times!!!!";
#ifnot; !--GRAMMARPOINT
	#ifdef CODEPOINT; !--if last processed the code section then move on to the grammar
		constant GRAMMARPOINT;
		message "Preparing to process extensions GRAMMAR section...";
	#ifnot; !--CODEPOINT
		#ifdef MESSAGEPOINT; !--if last processed the message section then move on to the code
			constant CODEPOINT;
			message "Preparing to process extensions CODE section...";
		#ifnot; !--MESSAGEPOINT
			#ifdef REPLACEPOINT; !if last processed the replacement section then move on to the message
				constant MESSAGEPOINT; 
				message "Preparing to process extensions MESSAGE section...";
			#ifnot; !--REPLACEPOINT
				constant REPLACEPOINT; 
				message "Preparing to process extensions REPLACE section...";
			#endif; !--replacepoint
		#endif; !--messagepoint
	#endif; !--codepoint
#endif; !--GRAMMARPOINT
!--------------------------------------------------------------------------------------
!!! Includes begin here... Add additional library entries to the bottom of this list
!  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  - 
!--JustEnoughGlulx initializes itself based upon the existence of contstants that may be defined in modules, so it is best to include it first...
#ifdef USE_ORJustEnoughGlulx; #include "ORJustEnoughGlulx"; #endif; 
!  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  - 
#ifdef USE_ORAdjective; #include "ORAdjective"; #endif;
#ifdef USE_ORAskTellOrder; #include "ORAskTellOrder"; #endif;
#ifdef USE_ORBanner; #include "ORBanner";	#endif;
#ifdef USE_ORBetterChoice; #include "ORBetterChoice"; #endif;
#ifdef USE_ORBracketParserMsgs; #include "ORBracketParserMsgs"; #endif;
#ifdef USE_ORCantGoOdd; #include "ORCantGoOdd"; #endif;
#ifdef USE_ORCenter; #include "ORCenter"; #endif;
#ifdef USE_ORConverseMenu; #include "ORConverseMenu"; #endif;
#ifdef USE_ORDefer2ndReference; #include "ORDefer2ndReference";	 #endif;
#ifdef USE_ORDispensor; #include "ORDispensor"; #endif;
#ifdef USE_ORDistinctMeSelf; #include "ORDistinctMeSelf"; #endif;
#ifdef USE_ORDistinctRead; #include "ORDistinctRead"; #endif;
#ifdef USE_ORDoor; #include "ORDoor"; #endif;
#ifdef USE_ORDoorInit; #include "ORDoorInit"; #endif;
#ifdef USE_ORDynaMap; #include "ORDynaMap"; #endif;
#ifdef USE_ORDynaString; #include "ORDynaString"; #endif;
#ifdef USE_OREntryPoints; #include "OREntryPoints"; #endif;
#ifdef USE_ORExamWithContents; #include "ORExamWithContents"; #endif;
#ifdef USE_ORExits; #include "ORExits"; #endif;
#ifdef USE_ORFirstThoughts; #include "ORFirstThoughts"; #endif;
#ifdef USE_ORGibberish; #include "ORGibberish"; #endif;
#ifdef USE_ORHideDirectionWalls; #include "ORHideDirectionWalls"; #endif;
#ifdef USE_ORInfGlk; #include "ORInfGlk"; #endif;
#ifdef USE_ORInformLibrary; #include "ORInformLibrary"; #endif;
#ifdef USE_ORInsultCompli_KT; #include "ORInsultCompli_KT"; #endif;
#ifdef USE_ORKeyboard; #include "ORKeyboard"; #endif;
#ifdef USE_ORKeyboardPrimitive; #include "ORKeyboardPrimitive"; #endif;
#ifdef USE_ORKnowledgeScript; #include "ORKnowledgeScript"; #endif;
#ifdef USE_ORKnowledgeTopic; #include "ORKnowledgeTopic"; #endif;
#ifdef USE_ORKnowledgeWeb; #include "ORKnowledgeWeb"; #endif;
#ifdef USE_ORLibraryMessages; #include "ORLibraryMessages"; #endif;
#ifdef USE_ORLiquid; #include "ORLiquid"; #endif;
#ifdef USE_ORLookRoom; #include "ORLookRoom"; #endif;
#ifdef USE_ORMagic; #include "ORMagic"; #endif;
#ifdef USE_ORMenu; #include "ORMenu"; #endif;
#ifdef USE_ORMiniMenu; #include "ORMiniMenu"; #endif;
#ifdef USE_ORNameable; #include "ORNameable"; #endif;
#ifdef USE_ORNPC; #include "ORNPC"; #endif;
#ifdef USE_ORNPC_asktelllearn; #include "ORNPC_asktelllearn"; #endif;
#ifdef USE_ORNPC_converse; #include "ORNPC_converse"; #endif;
#ifdef USE_ORNPC_doverb; #include "ORNPC_doverb"; #endif;
#ifdef USE_ORNPC_interact; #include "ORNPC_interact"; #endif;
#ifdef USE_ORNPC_MapKnown; #include "ORNPC_MapKnown"; #endif;
#ifdef USE_ORNPC_moods; #include "ORNPC_moods"; #endif;
#ifdef USE_ORNPC_movement; #include "ORNPC_movement"; #endif;
#ifdef USE_ORNPCVerb; #include "ORNPCVerb"; #endif;
#ifdef USE_ORNumberedContainer; #include "ORNumberedContainer"; #endif;
#ifdef USE_ORObjectInitialise; #include "ORObjectInitialise"; #endif;
#ifdef USE_OROptionList; #include "OROptionList";	#endif;
#ifdef USE_OROptionListMenu; #include "OROptionListMenu"; #endif;
#ifdef USE_ORParser; #include "ORParser"; #endif;
#ifdef USE_ORParseToken; #include "ORParseToken"; #endif;
#ifdef USE_ORPathMaker; #include "ORPathMaker";	 #endif;
#ifdef USE_ORPrefixSuffix; #include "ORPrefixSuffix"; #endif;
#ifdef USE_ORPronoun; #include "ORPronoun"; #endif;
#ifdef USE_ORProp; #include "ORProp"; #endif;
#ifdef USE_ORRandom; #include "ORRandom"; #endif;
#ifdef USE_ORRecogName; #include "ORRecogName"; #endif;
#ifdef USE_ORRedefineObject; #include "ORRedefineObject"; #endif;
#ifdef USE_ORReferByContents; #include "ORReferByContents"; #endif;
#ifdef USE_ORReverseDirection; #include "ORReverseDirection"; #endif;
#ifdef USE_ORRockDispensor; #include "ORRockDispensor"; #endif;
#ifdef USE_ORRoutinesList; #include "ORRoutinesList"; #endif;
#ifdef USE_ORSeveral; #include "ORSeveral"; #endif;
#ifdef USE_ORSpecializedExit; #include "ORSpecializedExit"; #endif;
#ifdef USE_ORStartingTurn; #include "ORStartingTurn"; #endif;
#ifdef USE_ORStyleHint; #include "ORStyleHint"; #endif;
#ifdef USE_ORStyleItalics; #include "ORStyleItalics"; #endif;
#ifdef USE_ORStyleRvrsMonospace; #include "ORStyleRvrsMonospace"; #endif;
#ifdef USE_ORSupporterContainer; #include "ORSupporterContainer"; #endif;
#ifdef USE_ORSuppressTakeAll; #include "ORSuppressTakeAll"; #endif;
#ifdef USE_ORTextFormatting; #include "ORTextFormatting"; #endif;
#ifdef USE_ORTransition; #include "ORTransition"; #endif;
#ifdef USE_ORUniqueMultiMessage; #include "ORUniqueMultiMessage"; #endif;
#ifdef USE_ORWAE_Formatting; #include "ORWAE_Formatting"; #endif;
#ifdef USE_ORWriteAfterEntry; #include "ORWriteAfterEntry"; #endif;
#ifdef USE_PersonalReuse; #include ">Reuse.h"; #endif;		!---personal library additions (user-defined)